//+------------------------------------------------------------------+
//|                                                   EURUSD Arb.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#import "c:\4xArb\EURUSD.dll"
   int set_terminal_1(double,double);
   double get_terminal_2_bid();
   double get_terminal_2_ask();
#import

#include <IBFX - Quick Scripts.mqh>

//External Variables:
extern bool    varStopEA=false;
extern int     varStopLoss=200;
extern int     varTakeProfit=10;
extern int     varSpreadProtect=40;
extern int     varSlippage=30;
extern int     varUseMM=false;
extern double  varRisk=0.03;
extern color   varOtherAColor=Tomato;
extern color   varOtherBColor=Aqua;

int varOrderMagicNumber=0;
bool varFridayOK, varTimeOK;
double varOtherB=0, varOtherA=0;

int init()
  {
   varOrderMagicNumber=funcGenerateMagicNumber(Period());
   if (varOrderMagicNumber==0)
   {
      varStopEA=true;
      Alert("The EA will not operate due to ",Symbol()," not being found int the EA symbol table");
   }
   return(0);
  }

int deinit()
  {

   return(0);
  }

int start()
  {
   static int varSignal=7, i=0;
   static bool varNoOrder=true;
   varFridayOK=true; varTimeOK=true;
	ObjectCreate("OtherA",OBJ_HLINE,0,0,0);
	ObjectSet("OtherA",OBJPROP_COLOR,varOtherAColor);
	ObjectCreate("OtherB",OBJ_HLINE,0,0,0);
	ObjectSet("OtherB",OBJPROP_COLOR,varOtherBColor);
   while(IsTradeAllowed())
   {
      RefreshRates();
      if (IsConnected()) {set_terminal_1(Ask,Bid);}
      if (!IsConnected()) {set_terminal_1(0,0);}
      varOtherA=get_terminal_2_ask();
      varOtherB=get_terminal_2_bid();
      ObjectMove("OtherA",0,Time[0],varOtherA);
	   ObjectMove("OtherB",0,Time[0],varOtherB);
      varSignal=funcGenerateSignal();
      Comment("Signal is ",varSignal,"\n",
              "Spread is ",MarketInfo(Symbol(),MODE_SPREAD),"\n",
              "Freeze is ",MarketInfo(Symbol(),MODE_FREEZELEVEL));
      for (i=0; i<OrdersTotal(); i++)
      {//1 +cycle by orders search
         if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
         if (OrderMagicNumber()!=varOrderMagicNumber) continue;
         varNoOrder=funcCloseOrder(OrderType(),varSignal);
      }
      if (varNoOrder && varOtherA != 0 && varOtherB != 0) 
      {
         varFridayOK=funcFridayOK();
         varTimeOK=funcCheckTime(10);
         if (varStopEA || !varTimeOK) {return(0);}
         procOpenOrder(varSignal);         
      }
      Sleep(100);
   }
   ObjectDelete("OtherA");
   ObjectDelete("OtherB");   
   return(0);
  }
//+------------------------------------------------------------------+

int funcGenerateSignal()
{
	static int varReturnValue=3;
	static bool varSpread=true;
	static int varDistance=0;
	varDistance=MathMax(MarketInfo(Symbol(),MODE_SPREAD),MarketInfo(Symbol(),MODE_FREEZELEVEL));
	if (varOtherA==0 || varOtherB==0) {return(3);}
	//check spreads
	if (MarketInfo(Symbol(),MODE_SPREAD) > varSpreadProtect) {varSpread=false;}

	//check directions
	if (Ask < varOtherB && varSpread && (varOtherB-Ask)/Point > varDistance)//long
		{varReturnValue=1;}
	if (Bid > varOtherA && varSpread && (Bid-varOtherA)/Point > varDistance)//short
		{varReturnValue=2;}
	if (Ask < varOtherB && varSpread && (varOtherB-Ask)/Point < varDistance)//long
		{varReturnValue=0;}
	if (Bid > varOtherA && varSpread && (Bid-varOtherA)/Point < varDistance)//short
		{varReturnValue=0;}
   return(varReturnValue);
}

bool funcCloseOrder(int varOrderType, int varSig)
{
   static bool varReturnValue=false;
   if (varOrderType==OP_BUY && varSig==3)//( || 
      {
         varReturnValue=CloseAll(Symbol(),varOrderMagicNumber,varOrderType,10,varSlippage," ");
       }
   if (varOrderType==OP_SELL && varSig==3)//( || 
      {
         varReturnValue=CloseAll(Symbol(),varOrderMagicNumber,varOrderType,10,varSlippage," ");
      }
   return(varReturnValue);   
}

void procOpenOrder(int varSignal)
{
   //static double varLots=MM(Symbol(),varRisk);varBBDiff,varBBDiffOld;
   static double varLots=1.0;
   if (varUseMM==true) {varLots=MM(Symbol(),varRisk );}
   static int varTicket=0;
   if (MarketInfo(Symbol(),MODE_SPREAD)+varTakeProfit<MarketInfo(Symbol(),MODE_FREEZELEVEL)) 
   {varTakeProfit=MarketInfo(Symbol(),MODE_FREEZELEVEL)-MarketInfo(Symbol(),MODE_SPREAD)+1;}
   if (varSignal==1) {varTicket=EnterLong(Symbol(),varLots," ",varStopLoss,varTakeProfit,varOrderMagicNumber,10,varSlippage);}
   if (varSignal==2) {varTicket=EnterShrt(Symbol(),varLots," ",varStopLoss,varTakeProfit,varOrderMagicNumber,10,varSlippage);}
}

bool funcFridayOK()
{
    static bool varReturnFridayValue=true;
    static datetime curtime=0;
    curtime=Time[0];
    static int theday=0;
    theday=TimeDay(curtime);
//   static int themonth=TimeMonth(curtime);
//   static int theyear=TimeYear(curtime);
    static int thehour=0;
    thehour=TimeHour(curtime);
//   static int theminute=TimeMinute(curtime);
   if (theday==5 && thehour>18) {varReturnFridayValue=false;}
   return(varReturnFridayValue);
}

bool funcCheckTime(int varStuff)
{
   //see Forex Trading and Probabilites for Times to trade.
   static datetime varReturnTime=false;
   static datetime curtime=0;
   curtime=Time[0];
   static datetime lasttime=0;
   lasttime=Time[varStuff];
   static double PeriodSeconds=0;
   PeriodSeconds=varStuff*Period()*60;
   if ((curtime-lasttime)<=PeriodSeconds) {varReturnTime=true;}
   return(varReturnTime);  
}

bool funcIsNewBar(int timeFrame)
{
   static datetime res=false;
   
   // the array contains open time of the current (zero) bar
   // for 7 (seven) timeframes
   static datetime _sTime[7];  
   static int i=6;
   //Note: i below will be 6 or timeframe will be day.
   switch (timeFrame) 
      {
      case 1  : i=0; break;
      case 5  : i=2; break;
      case 15 : i=3; break;
      case 30 : i=4; break;
      case 60 : i=5; break;
      case 240: break;
      case 1440:break;
      default:  timeFrame = 1440;
      }
//----
   if (_sTime[i]==0 || _sTime[i]!=iTime(Symbol(),timeFrame,0))
      {
      _sTime[i] = iTime(Symbol(),timeFrame,0);
      res=true;
      }
      
//----
   return(res);   
   }

int funcGenerateMagicNumber(int vartempTimeframe)
{
   static int vartempTimeframeval=0;
   vartempTimeframeval=funcTimeFrame_Const2Val(vartempTimeframe);
   static int vartempSymbol=0;
   vartempSymbol=funcSymbol2Val(StringSubstr(Symbol(),0,6));
   if (vartempSymbol==00) {return(vartempSymbol);}
   return(vartempTimeframeval+vartempSymbol);    
}
//+------------------------------------------------------------------+
//| Time frame static interval appropriation  function                      |
//+------------------------------------------------------------------+
int funcTimeFrame_Const2Val(int varConstant) 
{
   switch(varConstant) 
   {
      case 1:  
         return(1000);
      case 5:  
         return(2000);
      case 15:
         return(3000);
      case 30:
         return(4000);
      case 60:
         return(5000);
      case 240:
         return(6000);
      case 1440:
         return(7000);
      case 10080:
         return(8000);
      case 43200:
         return(9000);
   }
}
//+------------------------------------------------------------------+
//| Time frame static string appropriation  function                               |
//+------------------------------------------------------------------+
string funcTimeFrame_Val2static (int varValue) 
{
   switch(varValue) 
   {
      case 1:  
         return("PERIOD_M1");
      case 2:  
         return("PERIOD_M5");
      case 3:
         return("PERIOD_M15");
      case 4:
         return("PERIOD_M30");
      case 5:
         return("PERIOD_H1");
      case 6:
         return("PERIOD_H4");
      case 7:
         return("PERIOD_D1");
      case 8:
         return("PERIOD_W1");
      case 9:
         return("PERIOD_MN1");
   	default: 
   		return("undefined " +varValue);
   }
}

int funcSymbol2Val(string varSymbol) 
{
   static string varMySymbol = " ";
   varMySymbol=StringSubstr(Symbol(),0,6);
	if(varMySymbol=="AUDCAD") return(1);
	if(varMySymbol=="AUDJPY") return(2);
	if(varMySymbol=="AUDNZD") return(3);
	if(varMySymbol=="AUDUSD") return(4);
	if(varMySymbol=="CHFJPY") return(5);
	if(varMySymbol=="EURAUD") return(6);
	if(varMySymbol=="EURCAD") return(7);
	if(varMySymbol=="EURCHF") return(8);
	if(varMySymbol=="EURGBP") return(9);
	if(varMySymbol=="EURJPY") return(10);
	if(varMySymbol=="EURUSD") return(11);
	if(varMySymbol=="GBPCHF") return(12);
	if(varMySymbol=="GBPJPY") return(13);
	if(varMySymbol=="GBPUSD") return(14);
	if(varMySymbol=="NZDUSD") return(15);
	if(varMySymbol=="USDCAD") return(16);
	if(varMySymbol=="USDCHF") return(17);
	if(varMySymbol=="USDJPY") return(18);
	if(varMySymbol=="NZDJPY") return(19);
	if(varMySymbol=="AUDCHF") return(20);	
	if(varMySymbol=="EURNZD") return(21);
	if(varMySymbol=="GBPNZD") return(22);	
	if(varMySymbol=="NZDCHF") return(23);	
	if(varMySymbol=="USDGSD") return(24);	
	if(varMySymbol=="USDZAR") return(25);
	if(varMySymbol=="USDMXN") return(26);
	if(varMySymbol=="GBPAUD") return(27);
	if(varMySymbol=="CADJPY") return(28);
	if(varMySymbol=="GBPCAD") return(29);	
	return(00);
}


